/****
*     oMouse.Prg
*
*     NOTE:
*     -----
*     Not finished yet... Clipper 5.3 specific
*
*/

#include "oObject.ch"
#include "FTINT86.CH"

#define INT_MOUSE  51  //0x33

/*---------------------------------------------------------------------------*/
CLASS Mouse

DATA nRow, nCol     AS 0
DATA nButtons       AS 2
DATA lDriver        AS LOGIC
DATA cSave          AS ""
DATA MOn()          INLINE MSetCursor( .t. ) NOSELF
DATA MOff()         INLINE MSetCursor( .F. ) NOSELF
DATA Row()          INLINE ::nRow := MRow()  NOSELF
DATA Col()          INLINE ::nCol := MCol()  NOSELF
DATA IsMouse()      INLINE MPresent()        NOSELF
DATA Save()         INLINE ::cSave := MSaveState()
DATA Rest()         INLINE MRestState(::cSave)
DATA Bounds( nT, nL, nB, nR ) ;
                    INLINE MSetBounds( nT, nL, nB, nR )

METHOD New          = omNew
METHOD MInArea      = omMInArea
METHOD Reset        = omReset()

ENDCLASS


/*---------------------------------------------------------------------------*/
METHOD FUNCTION  omNew()
/*---------------------------------------------------------------------------*/
::Reset()
::MOn()
::MRow() ; ::MCol()
MSetCursor( .T. )
Return self

/*---------------------------------------------------------------------------*/
Function omMInArea( nT, nL, nB, nR )
/*---------------------------------------------------------------------------*/
Local nMrow  := ::MRow()
LOCAL nMCol  := ::MCol()
local retval := .f.

if nMrow >= nT .and. nMrow <= nB .and. nMcol >= nL .and. nMcol <= nR
    retval := .t.
endif

Return( retval )


/*---------------------------------------------------------------------------*/
METHOD FUNCTION omMReset()
/*---------------------------------------------------------------------------*/
Local aRegs[10]
aRegs[AX] := 0
FT_INT86( INT_MOUSE, aRegs )

::lDriver  := IF( aRegs[AX] == -1, .F., .T. )
::nButtons := IF( aRegs[BX] == -1,  2,   3  )
MSetCursor( .T. )
RETURN( self )
