#include "oobject.ch"
#include "Inkey.ch"
// #include "ord.ch"             // clipper 5.3 file - easily removed
#include "error.ch"
#include "fileio.ch"
#include "ferror.ch"

#xtranslate LStr(<n>)         =>   Ltrim(Str(<n>))
#xtranslate  CRLF(<foo>)      => (<foo> + CHR(13)+CHR(10))
#xtranslate  CRLF()           => CHR(13)+CHR(10)
#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  <uVar1> := If( <uVar1> == nil, <uVal1>, <uVar1> ) ;;
                [ <uVarN> := If( <uVarN> == nil, <uValN>, <uVarN> ); ]

#xtranslate IS_FIELD( <foo> )=> ( FIELDPOS( <foo> ) > 0 )
#xtranslate IS_OPEN( <foo> ) => ( SELECT( <foo> ) > 0 )
#xtranslate IS_VIRTUAL(<foo>)=> ( FIELDPOS( <foo> ) == 0 )

#define COLSEP1 "  "
#define COLSEP2 "  "

#define R_TITLE    1
#define R_DATA     2
#define R_LEN      3
#define R_PIC      4
#define R_COLSEP   5
#define R_TOTAL    6


/*
Ŀ
                         REPORT CLASS UDFs                                 

*/

#xcommand  DEFINE REPORT <oRep> ;
           [COLUMNS <aCols>]    ;
           [HEADER <aHead>]     ;
           [FOOTER <aFoot>]     ;
           [FILE <cFile>]       ;
           =>                   ;
           <oRep> := Repo():New( [<aHead>], [<aFoot>], [<aCols>], [<cFile>] )


#xCommand REPORT COLUMN [<cTitle>] ;
          [DATA <xData>]           ;
          [WIDTH <nLen>]           ;
          [PICTURE <cPic>]         ;
          [COLSEP <cColSep>]       ;
          [<lTotal:TOTAL>]         ;
          [IN <oRep>]              ;
          => ;
          [<oRep>:]AddColumn( { [<cTitle>], [<xData>], [<nLen>],;
                                [<cPic>], [<cColSep>],;
                                [<.lTotal.>] })

#xCommand RUN REPORT <oRep> ;
          => <oRep>:Exec()

