/****
*
*      oOTest1.prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      This example demonstrates the similarity of the oObject syntax
*      with oClip.
*
*/

#include "oobject.ch"

PROC TestIt()
LOCAL i, oSay
local n := seconds()

FOR i=1 TO 10000
     oSay := say():New("hello"+str(i),10,10,"n/w")
     oSay:Display()
NEXT
? seconds()-n
Return

/*---------------------------------------------------------------------------*/

CLASS SAY

VAR row, col, text
VAR color
VAR csave

METHOD New     = SayNew
METHOD display = Saydisplay

END CLASS

/*---------------------------------------------------------------------------*/

METHOD FUNCTION SayNew( cText, nRow, nCol, cColor )
      ::row   := nRow
      ::col   := nCol
      ::text  := cText
      ::color := cColor
      ::cSave := SaveScreen( ::row, ::col, ::row, ::col+len( ::text ) )

Return Self

/*---------------------------------------------------------------------------*/

METHOD FUNCTION SayDisplay()
  DispOutAt( ::row, ::Col, ::Text, ::Color )
RETURN self
