/****
*
*      oSayTst2.Prg
*      oObject Demonstration.
*
*      NOTE:
*      -----
*      Demonstrates use of LINK statement.
*      Constructor function is an INLINE block statement...
*      This class needs NO Method functions to run.
*/


#include "oobject.ch"

PROC TESTIT()
local i
local o := SAY():New( 5,30,"Hello There...", "gr+/r")
local nT
cls
o:ClassInfo()
? o:cColor

FOR i=1 TO 100
    o:cColor := FT_N2Color(i)   // from nanfor.lib
    o:nDisplay(i)
    o:Test1 := "Test"
next

o:Axit()

RETURN



/*---------------------------------------------------------------------------*/
CLASS Say ALIAS Say
/*---------------------------------------------------------------------------*/
DATA test

DATA Display INLINE ;
             DispOutAt( ::nRow, ::nCol, ::cSay, ::cColor )

DATA nDisplay( n ) INLINE ;
             DispOutAt( ::nRow, ::nCol, ::cSay+if(n!=NIL,str(n),""), ::cColor )

DATA nRow, nCol, cSay
DATA cColor AS "W+/B" LINK ALERT
DATA test1 AS "test" LINK aalert

METHOD ALERT  INLINE alert("Color Change...by cColor"+::cColor,,::cColor)
METHOD AALERT INLINE alert("::Test Method calling",,::cColor)
METHOD New( nR, nC, cS, cC ) INLINE ;
                             ::nRow := nR, ::nCol:= nC,;
                             ::cSay := cS, ::cColor := cC

METHOD virtMeth1 VIRTUAL
METHOD virtMeth2 DEFERRED

ENDCLASS

