/*
Ŀ
  CLIPOO.CH                                                                   
Ĵ
  Internal Clipper Class creation implementation                              
  (c) 1995-96-97-98 Manos Aspradakis                                          
  ASCO Tours, 18010 Aegina Island, Greece                                     
Ĵ
  See oSay.prg for a real class implementation example                        
  Written 05/11/1995                                                          
  Modified 03/05/1996                                                         
  Modified 20/07/1997                                                         

*/

#ifndef _CLIPOO_CH_

#xTranslate ::  => QSelf():

//Init Class ---------------------------------------------------------------
#xTranslate CLASS <constructor> NAME <classname> [FROM <xSuper>]=>;
           Function <constructor>() ;;
           Static nClassH := 0 ;;
           Local oNew ;;
           if nClassH == 0 ;;
           nClassH := __ClassNew( <"classname">, ( Len( ClassData(nClassH))/2 ) );;
           Aeval( ClassData(),    {|e| __ClassAdd( nClassH, e\[\1], e\[\2] )});;
           Aeval( ClassMethods(), {|e| __ClassAdd( nClassH, e\[\1], e\[\2] )});;
           END ;;
           oNew :=__ClassIns( nClassH ) ;;
           Return(If( !Valtype(oNew)=="O", Alert("ERROR!!!;OBJECT: NOT Inserted !!!"), oNew) )

           // ---------------------------------------------------------------
           // Attempt to implement ::SUPER 
           // (In developement...)
           // ---------------------------------------------------------------
           //#xTranslate super: => nSuper:
           //[;STATIC FUNCTION GetSuper() ; Return(<"xSuper">)]
           //[__ClassAdd( nClassH, "SUPER", <"xSuper"> ) ];;


// Start Data area... ------------------------------------------------------
#xCommand  CLASS DATA[:] =>;
         Static Function ClassData() ;;
         LOCAL cCnt := 0             ;;
         Local aData := {}

#xCommand  BEGIN DATA[:] =>;
         CLASS DATA

// ---------------------------------------------------------------
// Attempt to implement ::SUPER
// (In developement)
// ---------------------------------------------------------------
#xCommand  SET SUPER TO <xSuper> =>;
         AADD( aData, { "SUPER", <"xSuper"> } )

#xCommand  DATA <dataname>, <datafunc> =>;
         cCnt++ ;;
         AADD( aData, { <"dataname">, <"datafunc"> } ) ;;
         AADD( aData, { "_"+<"dataname">, <"datafunc"> } )

#xCommand  VAR <dataname>, <datafunc> =>;
         DATA <dataname>, <datafunc>

// End Data Area -----------------------------------------------------------
#xCommand  END DATA =>;
          Return( aData )


// Start Methods Area ------------------------------------------------------

#xCommand  CLASS METHODS[:] =>;
         Static Function ClassMethods() ;;
         Local aMethods := {}
        // ---------------------------------------------------------------
        // Attempt to implement ::SUPER
        // (In developement)
        // ---------------------------------------------------------------
        //;  if GetSuper() !=NIL ;;
        //     AADD( aMethods, { "SUPER", GetSuper() } ) ;;
        //  end

// Define Methods Area -----------------------------------------------------
#xCommand  BEGIN METHODS[:] =>;
         Static Function ClassMethods() ;;
         Local aMethods := {}

#xCommand  METHOD <methodname>, <methodfunc> =>;
           AADD( aMethods, { <"methodname">, <"methodfunc"> } )

#xCommand  METHOD <methodname> =>;
           AADD( aMethods, { <"methodname">, <"methodname"> } )

#xCommand  MESSAGE <methodname> METHOD <methodfunc> =>;
           METHOD <methodname>, <methodfunc>

#xCommand  MESSAGE <methodname> = <methodfunc> =>;
           METHOD <methodname>, <methodfunc>


// End Methods Area ------------------------------------------------------
#xCommand  END METHODS =>;
          Return( aMethods )


// End Class Area --------------------------------------------------------
#xCommand  END CLASS =>
#xCommand  ENDCLASS  =>


// Method/Data GetSet Funcs ----------------------------------------------
#xtranslate METHOD <MethodName>( [<uParms,...>] ) [CLASS <ClassName>] => ;
            Function <MethodName>([<uParms>] )  ;;
            Local Self := QSelf()


// READ Only Data IVars Methods ------------------------------------------
#xTranslate DEFINE DATA <xmethod> OF <uParm> [READONLY]  => ;
            FUNCTION <xmethod>(xVal)                        ;
           ;RETURN(<uParm>)

#xTranslate DATA METHOD <xmethod> OF <uParm> [READONLY] => ;
            DEFINE DATA <xmethod> OF <uParm> [READONLY]

#xTranslate VAR METHOD <xmethod> OF <uParm> [READONLY] => ;
            DEFINE DATA <xmethod> OF <uParm> [READONLY]


// Get-Set Data IVars Methods --------------------------------------------
#xTranslate DEFINE DATA <xmethod> OF <uParm> GETSET => ;
            FUNCTION <xmethod>(xVal)                     ;
           ;RETURN(IF(xVal == NIL, <uParm>, <uParm>:=xVal))

#xTranslate DATA METHOD <xmethod> OF <uParm> GETSET => ;
            DEFINE DATA <xmethod> OF <uParm> GETSET

#xTranslate VAR METHOD <xmethod> OF <uParm> GETSET => ;
            DEFINE DATA <xmethod> OF <uParm> GETSET


#define _CLIPOO_CH_
#endif
//---------------------------- EOF ClipOO.ch -------------------------------//
