
#define _AX         1
#define _BX         2
#define _CX         3
#define _DX         4
#define _SI         5
#define _DI         6
#define _BP         7
#define _DS         8
#define _ES         9
#define _FLAGS     10

#translate REG_DS               => .T.  //1
#translate REG_ES               => .F.  //0

#translate ISLOGIC(<arg>)       => (<arg> = .F. .OR. <arg> = .T.)

#translate highbyte( <X> ) => (int( if((<X>) \< 0, 65536+(<X>), (<X>)) / 256))
#translate lowbyte( <X> )  => (     if((<X>) \< 0, 65536+(<X>), (<X>)) % 256)
