#include "oobject.ch"

#translate GETSET( <xVal>, <xParm> ) => ;
           <xVal> := IF( <xParm> == NIL, <xVal>, <xVal> := <xParm>)

/****
*
*     Replacement for the TBColumn Class class.
*     Can be inherited using the oobject.lib
*
*     Note:
*     -----
*     This code is 5.3 specific. To convert it to 5.2 erase the 5.3 methods
*     and IVars from the class.
*
*/

// Shell function
//
FUNCTION DBColumnNew(cHead, bData)
//
Local oCol := oTBColumn():TBColumnNew(cHead, bData)
Return oCol

//
CLASS oTBColumn

DATA oCol
DATA bInit, bEnd
DATA Slot1, Slot2

METHOD  New(c, b)    INLINE  ::oCol := TbColumnNEW( c, b )
METHOD SetStyle(x,y) INLINE  ::oCol:SetStyle(x, y)

DATA   block(x)      INLINE  GETSET( ::oCol:block, x )      NOSELF
DATA   cargo(x)      INLINE  GETSET( ::oCol:cargo, x )      NOSELF
DATA   colorBlock(x) INLINE  GETSET( ::oCol:colorblock, x ) NOSELF
DATA   colSep(x)     INLINE  GETSET( ::oCol:colsep, x )     NOSELF
DATA   defColor(x)   INLINE  GETSET( ::oCol:defcolor, x )   NOSELF
DATA   footing(x)    INLINE  GETSET( ::oCol:footing, x )    NOSELF
DATA   footSep(x)    INLINE  GETSET( ::oCol:footsep, x )    NOSELF
DATA   heading(x)    INLINE  GETSET( ::oCol:heading, x )    NOSELF
DATA   headSep(x)    INLINE  GETSET( ::oCol:headsep, x )    NOSELF
DATA   picture(x)    INLINE  GETSET( ::oCol:picture, x )    NOSELF
DATA   postBlock(x)  INLINE  GETSET( ::oCol:postblock, x )  NOSELF
DATA   preBlock(x)   INLINE  GETSET( ::oCol:preblock, x )   NOSELF
DATA   width(x)      INLINE  GETSET( ::oCol:width, x )      NOSELF
ENDCLASS
