#include "oObject.ch"
/****
*
*     oObjTest.Prg
*     oObject demonstration
*
*     Demonstrates Aliased inheritance, calling parent constructor method
*     from within a child INLINE method and polymorphism using aliased
*     parent methods. Also demonstrates inheritance of parent IVars and
*     access/assign of parent IVars by child classes.
*/


Proc TestInherit()
Local a := ParentCls():New()
Local o := Child():New( 10,10 )
a:ClassInfo()
o:ClassInfo()
scroll()
o:Data1:= "= Test #1"
o:Data2:= "= Test #2"
o:Data3:= "= Test #3"
o:Disp()
inkey(0)

scroll()
o:nRow := 15
o:nCol := 60
o:Data1:= "= Test #4"
o:Data2:= "= Test #5"
o:Data3:= "= Test #6"
o:Disp()
inkey(0)
return

//
CLASS ParentCls ALIAS oP

Data Data1, Data2, Data3  AS "o"

METHOD New()         INLINE  ::Data1 := "",;
                             ::Data2 := "",;
                             ::Data3 := ""

METHOD Disp(nR, nC)  INLINE scroll(), ;
                            DispOutAt(   nR,  nC  , "::Data1 " + ::Data1 ),;
                            DispOutAt( ++nR,++nC  , "::Data2 " + ::Data2 ),;
                            DispOutAt( ++nR,++nC  , "::Data3 " + ::Data3 )

ENDCLASS

//
CLASS Child FROM ParentCls
DATA nRow, nCol
METHOD  New( nRow, nCol )  INLINE ::nRow := nRow, ;
                                  ::nCol := nCol

METHOD  Disp()             INLINE ;
                           Alert( "Child ::Disp();Calls ::Super:Disp()",,"N/G" ), ;
                           ::oPDisp(::nRow, ::nCol)
ENDCLASS

