/****
*
*      oOTest2.prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates inheritance and on-the-fly addition of instance
*      variables at runtime. Note how ::NewIVar2 alters the ::text
*      IVar of it's class
*
*/

#include "oobject.ch"

Proc test()
Local oSay,i

cls

oSay := Say():New( "Hello There...", 10,10,"gr+/b")
? "oSay:Text  ", oSay:Text
? "oSay:Row   ", oSay:Row
? "oSay:Col   ", oSay:Col
? "oSay:Color ", oSay:Color
oSay:Display()

oSay:Row := 15 ; oSay:Col := 35 ; oSay:Text := "WELCOME TO OOPs........."
oSay:Display()
inkey(0)

oSay:ClassInfo()
oSay:Hide()
cls

//-> Insert two IVars.
//-> ::TestData2 also interacts with the rest of the class
//-> altering an existing IVar.

oSay:InsData("NewIVar1",,"Test Data...")
oSay:InsData("NewIvar2",{|x| x:text:= "Now changed by ::NewIVar2", x:display() })
? "oSay:NewIvar1", oSay:NewIVar1
oSay:display()
?
? "Press a key to change ::text using the new inserted IVar..."
inkey(0)

oSay:NewIvar2()
oSay:row -= 5
oSay:display()
inkey(0)
oSay:Hide()

Alert( "Say2() class from Say() demonstration...",, "w+/b" )

FOR i=1 TO 10
    oSay := Say2():New(i)
    osay:classinfo()
    oSay:Display()
    inkey(0)
next

Return


/*---------------------------------------------------------------------------*/

CLASS SAY
DATA Row,Col,Text,Color,cSave

DATA Len     INLINE  Len( ::Text ) NOSELF
DATA Save    INLINE ::cSave := SaveScreen( ::row, ::Col, ;
                                           ::row, ::Col + ::Len() )
DATA Display INLINE ::Save(), ;
                    DispOutAt( ::row, ::Col, ::Text, ::Color )

DATA Hide    INLINE RestScreen( ::Row, ::Col, ;
                                ::Row, ::Col + ::Len(), ::cSave )

METHOD New = SayNew

END CLASS


METHOD FUNCTION SayNew( cText, nRow, nCol, cColor )
  ::row   := nRow
  ::col   := nCol
  ::text  := cText
  ::color := cColor
  ::cSave := SaveScreen( ::row, ::col, ::row, ::col+len( ::text ) )
Return Self


/*---------------------------------------------------------------------------*/

CLASS SAY2 FROM SAY ALIAS SAY2
METHOD New = SAY2NEW
ENDCLASS

METHOD FUNCTION SAY2NEW(n)
::color := "w+/r"
::Text  := "THIS IS SAY2 CLASS..."+str(n,3) +" Handle :"+str(::dict:handle,3)
::row := 20
::col := 30
::display()
RETURN SELF
