/****
*
*      TestSta2.Prg
*      oObject Demonstration.
*
*      Notes:
*      ------
*      Demonstrates use of STATIC Methods. Base class BOX.
*      Parent to class WINDOW in TestSta2.prg
*/

#include "oobject.ch"

// Test the BOX class
PROC MoveBox()
Local o := box():New( 10,10,20,30):Display()
inkey(0)

o:Hide()
o:nTop-=3     ; o:nLeft-=3
o:nBottom-=3  ; o:nRight-=3
o:Display()
inkey(0)

o:Hide()
o:nTop-=3     ; o:nLeft-=3
o:nBottom-=3  ; o:nRight-=3
o:Display()

RETURN

//
CLASS Box ALIAS Box

EXPORT:
DATA nTop, nLeft        AS 0
DATA nBottom, nRight    AS 20
DATA cBox, cColor
DATA cSave

METHOD New( a,b,c,d,e,f )            // STATIC Constructor Method
METHOD Display()                     // STATIC Method
METHOD Hide = _BOXHide               // PUBLIC Method

ENDCLASS



//
METHOD New( a,b,c,d,e,f ) //CLASS test
DEFAULT  e:= replicate(" ",9),;
         f:="n/w"

::nTop    := a
::nLeft   := b
::nBottom := c
::nRight  := d
::cBox    := e
::cColor  := f
::cSave   := SaveScreen( a,b,c,d )
RETURN Self


//
METHOD Display() //CLASS test
DispBegin()
::cSave   := savescreen(::nTop, ::nLeft, ::nBottom, ::nRight)
DispBox( ::nTop, ::nLeft, ::nBottom, ::nRight, ::cBox, ::cColor )
DispEnd()
Return Self



//
METHOD FUNCTION _BoxHide()
DispBegin()
RestScreen( ::nTop, ::nLeft, ::nBottom, ::nRight,::cSave )
DispEnd()
Return Self
