//
//  oObject2.ch
//  (c) 1997-1998, Manos Aspradakis
//
//  Method definition for compatibility with Objects.lib
//  and STATIC Methods implementation.
//

#ifndef _OOBJECT2_CH_

#undef METHOD

#xCommand METHOD <MethodName> ;
          => ;
          STATIC Function <MethodName>( self )

#xCommand METHOD <MethodName>() ;
          => ;
          STATIC Function <MethodName>( self )

#xCommand METHOD <MethodName>( [<uParms,...>] ) ;
          => ;
          STATIC Function <MethodName>( self [,<uParms>] )

#xCommand METHOD <cMessage> = <cMethod> ;
          => ;
          oObj:AddMethod( <"cMessage">, <"cMethod">, cAlias, oObj:Scope )

#define _OOBJECT2_CH_
#endif
